#!/bin/sh

#  AirDrop_patch.sh
#  
#
#  Created by oliveira131 on 21/10/19.
#  

Check_SIP()
{
    echo "Checking System Integrity Protection status."
    if [[ $(csrutil status | grep status) == *disabled* || $(csrutil status | grep status) == *unknown* ]]; then
        echo "System Integrity Protection status check passed."
    else
        echo "System Integrity Protection status check failed."
        echo "Disable SIP First."
        exit
    fi
}

Check_SIP

sudo mount -uw / ; killall Finder

PLACA="$(ioreg -l | grep "board-id" | awk -F\" '{print $4}')";

SUB='s/\Mac-00BE6ED71E35EB86/\'${PLACA}'/';

sudo cp "/System/Library/Frameworks/IOBluetooth.framework/Versions/A/Resources/SystemParameters.plist" "/System/Library/Frameworks/IOBluetooth.framework/Versions/A/Resources/SystemParameters.plist.bkp"

sudo cp /System/Library/Extensions/IO80211Family.kext/Contents/PlugIns/AirPortBrcm4360.kext/Contents/MacOS/AirPortBrcm4360 /System/Library/Extensions/IO80211Family.kext/Contents/PlugIns/AirPortBrcm4360.kext/Contents/MacOS/AirPortBrcm4360.bkp

sudo cp /System/Library/Extensions/IO80211Family.kext/Contents/PlugIns/AirPortBrcmNIC.kext/Contents/MacOS/AirPortBrcmNIC /System/Library/Extensions/IO80211Family.kext/Contents/PlugIns/AirPortBrcmNIC.kext/Contents/MacOS/AirPortBrcmNIC.bkp

sudo /usr/libexec/PlistBuddy -c "Set:${PLACA}:ContinuitySupport true" "/System/Library/Frameworks/IOBluetooth.framework/Versions/A/Resources/SystemParameters.plist"

sudo -E perl -pi -e ${SUB} /System/Library/Extensions/IO80211Family.kext/Contents/PlugIns/AirPortBrcm4360.kext/Contents/MacOS/AirPortBrcm4360

sudo -E perl -pi -e ${SUB} /System/Library/Extensions/IO80211Family.kext/Contents/PlugIns/AirPortBrcmNIC.kext/Contents/MacOS/AirPortBrcmNIC

echo "Please wait, kext cache is being rebuilt..."

sudo kextcache -system-prelinked-kernel -all-loaded

sudo kextcache -system-caches

echo "AirDrop Patched, restart your computer and not forget: the cake is a lie!"
